/*
 *	chasm.h - chasm header file
 *
 *	@(#)chasm.h	1.1 91/04/10
 *
 *	Copyright (c) 1991 Steve Scherf
 *
 *	Author:	Steve Scherf
 *	Date:	Wed Apr 10 22:53:11 PDT 1991
 *----------------------------------------------------------------------
 *	Amiga porting:
 *	
 *	By:	Gian Uberto Lauri
 *	Date: Wed Jun 19 1991
 *
 *----------------------------------------------------------------------
 *	SUPERCHIPextension:
 *	
 *	By:	Gian Uberto Lauri
 *	Date: Mon Jun 24 1991
 *
 * Notes:
 *	I added the new tokens last, without care of their alphabetic
 *	order. I choosed 3 letters mnemonics for sake of consistency
 *	with the old code, and in most case they are acronyms.
 *
 *	ESA	Extended Screen Activation (Sorry, On wasn't a good choice)
 *	ESO	Extended Screen Off
 *	BYE	BYE (leave superchip - that's not an acronym :) )
 *	SDP	Set Digit Pointer
 *	WUF	Write User Flags (shut up doggie!)
 *	RUF	Read User Flags
 *	SCD	Scroll down n pixel
 *	SCR	Scroll right 4 pixel
 *	SCL	Scroll left 4 pixel
 *
 *	For more details about S-CHIP, see the relative posting.
 *	BTW, adding new instructions using bison/yacc is trivial.
 */

#include <stdio.h>

/* external definitions */
extern FILE *ifp;
extern int pars_err;
extern int add_lab();

#define	LOADADR	0x200	/* binaries are loaded at this address */
#define MAXADDR 0xFFF	/* maximum addressible memory location */

#define  STRING		257
#define  REG		258
#define  VAR		259
#define  CONST		260
#define  LABEL		261
#define  IBASE		262

/* instruction token definitions */
#define  ADD	0	/* add */
#define  AND	1	/* bitwise and */
#define  BCD	2	/* store BCD representation of a number */
#define  CLD	3	/* clear display */
#define  DATA	4	/* store numeric data in memory (pseudo-instruction) */
#define  DEF	5	/* define a constant (pseudo-instruction) */
#define  DMP	6	/* dump registers */
#define  DSP	7	/* display sprite at coordinates */
#define  INK	8	/* input keystroke */
#define  JMP	9	/* jump to instruction */
#define  JOF	10	/* jump to instruction at offset */
#define  JSR	11	/* jump to subroutine */
#define  MEM	12	/* allocate memory (pseudo instruction) */
#define  MOV	13	/* store a value */
#define  OR	14	/* bitwise or */
#define  RES	15	/* restore registers */
#define  RET	16	/* return from subroutine */
#define  RND	17	/* random number */
#define  SAR	18	/* subtract and replace */
#define  SEQ	19	/* skip if equal */
#define  SHL	20	/* bitwise left shift */
#define  SHR	21	/* bitwise right shift */
#define  SIP	22	/* skip if key pressed */
#define  SNE	23	/* skip if not equal */
#define  SNP	24	/* skip if not pressed */
#define  SSC	25	/* set sprite character */
#define  SUB	26	/* subtract */
#define  XOR	27	/* bitwise exclusive or */
#define  ESA	28	/* extended screen on */
#define  ESO	29	/* extended screen off (default) */
#define  BYE	30	/* leave superchip (like a <- keypressing) */
#define  SDP	31	/* Points I to 10-byte sprite for the
                            digit in VX (0..9) */
#define  WUF	32	/* Store V0..VX in RPL user flags (X<=7) */
#define  RUF	33	/* Read V0..VX from RPL user flags (X<=7) */
#define  SCD	34	/* Scroll down n pixel */
#define  SCR	35	/* scroll right 4 pixel */
#define  SCL	35	/* scroll left 4 pixel */

